function Df=n_body_diff(t, y)

global m;
global G;

d = 2;
nd = length(y)/2;
n = nd/2;
if( length(m)~= n)
   error('dimension mismatch');
end
Df = zeros(2*nd, 2*nd);
Df(1:nd, nd+1:2*nd) = eye(nd);
for i=1:n
   qi = y(d*(i-1)+1:d*i);
   for k=1:n
      qk = y(d*(k-1)+1:d*k);
      summat = zeros(d, d);
      if( i==k )
         for l = setdiff((1:n), i)
            ql = y(d*(l-1)+1:d*l);
            r = norm(qi - ql);
            q_li = (ql - qi)/r;
            summat = summat + m(l)*( eye(d) - 3*(q_li*q_li') )/(r^3);
         end
         summat = -G*summat;
      else
         r = norm(qi - qk);
         q_ki = (qk - qi)/r;
         summat = G*m(k)*( eye(d) - 3*(q_ki*q_ki') )/(r^3);
      end
      Df(nd+d*(i-1)+1:nd+d*i, d*(k-1)+1:d*k) = summat;
   end
end

